
(defparameter *use-loop-header-nodes* nil)

;; requires "c-reasoner-utils.lisp"
;; requires "base.lisp"

;; var := (list ACL2-var program-var)

(defun var.ACL2-var (var)
  (pair.first var))

(defun var.program-var (var)
  (pair.second var))

;; ======================================

;; N -> ACL2-expression
(defun adjust-counter (nondet-count)
  (if (equal nondet-count 0)
      'counter
    `(+ counter ,nondet-count)))

(defun unary-operator-to-ACL2-unary-operator (op)
  (cond ;;((equal op '-) '-)
	((equal op 'log-not) 'not)
	((equal op 'bin-not) 'c-uint-bin-not)
	(t (error 'unimplemented (list 'unimplemented 'unary 'op op)))))

(defun binary-operator-to-ACL2-binary-operator (op)
  (cond ((equal op '+) 'c-int-+)
	((equal op '-) 'c-int--)
	((equal op '*) 'c-int-*)
	((equal op '/) 'c-int-/)
	((equal op 'unsigned-+) 'c-uint-+)
	((equal op 'unsigned--) 'c-uint--)
	((equal op 'unsigned-*) 'c-uint-*)
	((equal op 'unsigned-/) 'c-uint-/)
	((equal op '==) 'equal)
	((equal op '!=) '/=)
	((equal op '>=) '>=)
	((equal op '>) '>)
	((equal op '<=) '<=)
	((equal op '<) '<)
	((equal op 'log-and) 'and)
	((equal op 'log-or) 'or)
	((equal op 'bin-and) 'c-uint-bin-and)
	((equal op 'bin-or) 'c-uint-bin-or)
	((equal op 'bin-xor) 'c-uint-bin-xor)
	((equal op 'mod) 'c-mod) 
	(t (error 'unimplemented (list 'unimplemented 'binary 'op op)))))


(define-condition no-type-to-ACL2-type (error)
  ((text :initarg :text :reader text)))

(define-condition no-basic-type-to-ACL2-type (error)
  ((text :initarg :text :reader text)))

;; type -> ACL2-type
(defun type-to-ACL2-type (type)
  (cond ((equal (car type) 'basic-type)
	 (cond ((equal (l.find type ':kind) 'bool)
		'c-bool)
	       ((equal (l.find type ':kind) 'char)
		'c-char)
	       ((equal (l.find type ':kind) 'int)
		'c-int)
	       ((equal (l.find type ':kind) 'uint)
		'c-uint)
	       (t (error 'no-basic-type-to-ACL2-type))))
	(t (error 'no-type-to-ACL2-type))))


(define-condition no-type-to-ACL2-type-type-recognizer (error)
  ((text :initarg :text :reader text)))

(define-condition no-basic-type-to-ACL2-type-recognizer (error)
  ((text :initarg :text :reader text)))

(defun type-to-ACL2-type-recognizer (type)
  (cond ((equal (car type) 'basic-type)
	 (cond ((equal (l.find type ':kind) 'bool)
		'c-boolp)
	       ((equal (l.find type ':kind) 'char)
		'c-charp)
	       ((equal (l.find type ':kind) 'int)
		'c-intp)
	       ((equal (l.find type ':kind) 'uint)
		'c-uintp)
	       (t (error 'no-basic-type-to-ACL2-type-recognizer))))
	(t (error 'no-type-to-ACL2-type-recognizer))))


(defun name-to-type (name)
  (intern (string name) "KEYWORD"))
(defun name-to-recognizer (name)
  (intern (string-append (string name) "P")))
(defun ACL2-type-to-recognizer (type)
  (cond ((equal type 'nat) 'natp)
	((equal type 'nondet) 'nondetp)
	((equal type 'c-bool) 'c-boolp)
	((equal type 'c-char) 'c-charp)
	((equal type 'c-int) 'c-intp)
	((equal type 'c-uint) 'c-uintp)))


#|
(defun result-name ()
  (gentemp "r"))
(defun expression-name ()
  (gentemp "e"))

;; ACL2-expression [ACL2-var list] ACL2-expression -> ACL2-expression
(defun to-ACl2-fill-in-context (exp args-to-pull-out hole)
  (let* ((result-var (result-name))
	 (cdr-list (cdr (list.map #'(lambda (_) 'cdr) args-to-pull-out)))
	 (pull-outs (pair.first (list.foldr
				 #'(lambda (var acc)
				     (let* ((acc-list (pair.first acc))
					    (cdr-list (pair.second acc))
					    (cdr-d-result (list.foldr
							   #'(lambda (x acc) (cons x (list acc)))
							   result-var cdr-list)))
				       (pair.make (cons `(,var (car ,cdr-d-result))
							acc-list)
						  (cdr cdr-list))))
				 (pair.make () cdr-list) args-to-pull-out))))
    `(let* ,(cons (list result-var exp)
		  pull-outs)
       ,hole)))
|#

;; ALC2-expression [ACL2-type list] -> ACL2-expression 
(defun create-output-contract (call types)
  (let* ((cdr-list (cdr (list.map #'(lambda (_) 'cdr) types))))
    (append (list 'and
		  `(true-listp ,call)
		  `(endp ,(list.foldr
			   #'(lambda (x acc) (cons x (list acc)))
			   call (cons 'cdr cdr-list))))
	    (pair.first (list.foldl 
			 #'(lambda (type acc)
			     (let* ((acc-list (pair.first acc))
				    (cdr-list (pair.second acc))
				    (cdr-d-call (list.foldr
						 #'(lambda (x acc) (cons x (list acc)))
						 call cdr-list)))
			       (pair.make (cons `(,type (car ,cdr-d-call))
						acc-list)
					  (cdr cdr-list))))
			 (pair.make () cdr-list) types)))))


;; symbol [ACL2-type list] -> ACL2-defdata
(defun defdata.make (name types)
  `(defdata ,name ,(cons 'list types)))
;; ACL2-defdata -> symbol
(defun defdata.name (defdata)
  (cadr defdata))

;; symbol ... -> ACL2.definec
(defun definec.make (name var-type-list output-type body)
  `(definec ,name ,var-type-list ,output-type ,body))
;; ACL2-definec -> symbol
(defun definec.name (definec)
  (cadr definec))
;; ACL2-definec -> [[symbol ACL2-type U] list]
(defun definec.vars (definec)
  (caddr definec))
;; ACL2-definec -> ACL2-type
(defun definec.output-type (definec)
  (cadddr definec))
;; ACL2-definec -> symbol
(defun definec.body (definec)
  (cadddr (cdr definec)))

;; symbol ... -> defun
(defun defun.make (name vars body)
  `(defun ,name ,var-type-list ,body))
;; defun -> symbol
(defun defun.name (def)
  (cadr definec))
;; defun -> symbol
(defun defun.body (def)
  (cadddr def))

(defun definec-to-defun (definec)
  `(defun ,(definec.name definec)
       ,(cadr (list.foldl #'(lambda (e acc)
			      (if (car acc)
				  (list nil (cons e (cadr acc)))
				(list t (cadr acc))))
			  (list t ()) (definec.vars definec)))
     ,(definec.body definec)))

;; ============================

(define-condition no-declaration (error)
  ((text :initarg :text :reader text)))
(define-condition no-statement (error)
  ((text :initarg :text :reader text)))
(define-condition no-expression (error)
  ((text :initarg :text :reader text)))

(defun lvalue-free-vars (exp)
  (lvalue-free-vars* exp ()))

(defun expression-free-vars (exp)
  (expression-free-vars* exp ()))

(defun statement-free-vars (stm)
  (statement-free-vars* stm ()))

(defun lvalue-free-vars* (lvalue free-vars)
  (list-union (list (list (var.ACL2-var (l.find lvalue ':var))
			  (type-to-ACL2-type (l.find lvalue ':type))))
	      free-vars))

;; expression -> [(list ACL2-var ACL2-type) list]
(defun expression-free-vars* (exp free-vars)
  (cond ((equal (car exp) 'literal-expression)
	 free-vars)
	((equal (car exp) 'id-expression)
	 (let* ((type (type-to-ACL2-type (l.find exp ':type)))
		(var (var.ACL2-var (l.find exp ':var))))
	   (list-union (list (list var type)) free-vars)))
	((equal (car exp) 'unary-expression)
	 (expression-free-vars* (l.find exp ':operand) free-vars))
	((equal (car exp) 'binary-expression)
	 (expression-free-vars* (l.find exp ':operand1) 
			       (expression-free-vars* (l.find exp ':operand2) free-vars)))
	((equal (car exp) 'nondeterministic-expression)
	 (list-union (list (list 'nondet 'nondet) (list 'counter 'nat)) free-vars))
	((equal (car exp) 'conditional-expression)
	 (expression-free-vars* (l.find exp ':test)
			       (expression-free-vars* (l.find exp ':then)
						     (expression-free-vars* (l.find exp ':else) free-vars))))
	(t (error 'no-expression (list exp)))))

;; statement -> [(list ACL2-var ACL2-type) list]
(defun statement-free-vars* (stm free-vars)
  (cond ((equal (car stm) 'compound-statement)
	 (list.foldr #'(lambda (stm* acc)
		       (statement-free-vars* stm* acc))
		     free-vars (l.find stm ':statements)))
	((equal (car stm) 'if-then-statement)
	 (expression-free-vars* (l.find stm ':test)
			       (statement-free-vars* (l.find stm ':then) free-vars)))
	((equal (car stm) 'if-then-else-statement)
	 (expression-free-vars* (l.find stm ':test)
			       (statement-free-vars* (l.find stm ':then)
						    (statement-free-vars* (l.find stm ':else) free-vars))))
	((equal (car stm) 'while-statement)
	 (expression-free-vars* (l.find stm ':test)
			       (statement-free-vars* (l.find stm ':body) free-vars)))
	((equal (car stm) 'do-statement)
	 (error 'unimplemented))
	((equal (car stm) 'for-statement)
	 (statement-free-vars* (l.find stm ':init)
			       (statement-free-vars* (l.find stm ':iter)
						     (statement-free-vars* (l.find stm ':body)
									   (expression-free-vars* (l.find stm ':test) free-vars)))))
	((equal (car stm) 'break-statement)
	 free-vars)
	((equal (car stm) 'continue-statement)
	 free-vars)
	((equal (car stm) 'empty-statement)
	 free-vars)
	((equal (car stm) 'declaration-statement)
	 (let* ((type (type-to-ACL2-type (l.find (l.find stm ':declaring) ':type)))
		(var (var.ACL2-var (l.find (l.find stm ':declaring) ':var))))
	 (list.remove (list var type)
		      (expression-free-vars* (l.find stm ':initializer)
					    free-vars))))
	((equal (car stm) 'assignment-statement)
	 (expression-free-vars* (l.find stm ':expression)
				(lvalue-free-vars* (l.find stm ':lvalue) free-vars)))
	((equal (car stm) 'expression-statement)
	 (error 'unimplemented))
	((equal (car stm) 'return-statement)
	 (expression-free-vars* (l.find stm ':expression) free-vars))
	((equal (car stm) 'assert-statement)
	 (expression-free-vars* (l.find stm ':expression) free-vars))
	((equal (car stm) 'goto-statement)
	 free-vars)
	((equal (car stm) 'label-statement)
	 free-vars)
	(t (error 'no-statement (list stm)))))

;; expression N -> (list ACL2-expression N)
;; the N is the nondet counter.
(defun expression-to-ACL2-expression* (exp nondet-count)
  (cond ((equal (car exp) 'literal-expression)
	 (let* ((type (type-to-ACL2-type (l.find exp ':type)))
		(value (l.find exp ':value))
		(body value))
	   (list body nondet-count)))

	((equal (car exp) 'id-expression)
	 (let* ((type (type-to-ACL2-type (l.find exp ':type)))
		(var (var.ACL2-var (l.find exp ':var)))
		(body var))
	   (list body nondet-count)))
	
	((equal (car exp) 'unary-expression)
	 (let* ((type (type-to-ACL2-type (l.find exp ':type)))
		(op (unary-operator-to-ACL2-unary-operator (l.find exp ':operator)))
		(body1-res (expression-to-ACL2-expression* (l.find exp ':operand) nondet-count))
		(body1 (car body1-res))
		(nondet-count* (cadr body1-res))
		(body `(,op ,body1)))
	   (list body nondet-count*)))

	((equal (car exp) 'binary-expression)
	 (let* ((type (type-to-ACL2-type (l.find exp ':type)))
		(op (binary-operator-to-ACL2-binary-operator (l.find exp ':operator)))
		(body1-res (expression-to-ACL2-expression* (l.find exp ':operand1) nondet-count))
		(body1 (car body1-res))
		(nondet-count* (cadr body1-res))
		(body2-res (expression-to-ACL2-expression* (l.find exp ':operand2) nondet-count*))
		(body2 (car body2-res))
		(nondet-count** (cadr body2-res))
		(body `(,op ,body1 ,body2)))
	   (list body nondet-count**)))

	((equal (car exp) 'nondeterministic-expression)
	 (let* ((type (type-to-ACL2-type (l.find exp ':type))))
	   (cond ((equal type 'c-bool)
		  (list `(nondet-c-bool nondet ,(adjust-counter nondet-count))
			(+ nondet-count 1)))
		 ((equal type 'c-char)
		  (list `(nondet-c-char nondet ,(adjust-counter nondet-count))
			(+ nondet-count 1)))
		 ((equal type 'c-uint)
		  (list `(nondet-c-uint nondet ,(adjust-counter nondet-count))
			(+ nondet-count 1)))
		 ((equal type 'c-int)
		  (list `(nondet-c-int nondet ,(adjust-counter nondet-count))
			(+ nondet-count 1))))))

	((equal (car exp) 'conditional-expression)
	 (error 'unimplemented))
	(t (error 'no-expression (list exp)))))

(defun node.create-defdata-context (node exp hole)
  (use-fill-in-context exp (list.map #'car (node.live-vars node)) hole))

(defun node.thm-hyps (node)
  (list.map #'(lambda (var-pair)
		(list (ACL2-type-to-recognizer (cadr var-pair))
		      (car var-pair)))
	    (node.live-vars node)))

(defun node.create-thm-context (node hole)
  (list 'implies
	(cons 'and (node.thm-hyps node))
	hole))

;; [(list ACL2-var ACL2-type) list] -> ACL2-defdata
(defun create-defdata (live-vars)
  `(defdata ,(new-defdata-name) ,(cons 'list (list.map #'cadr live-vars))))

;; ACL2-expression [ACL2-var list] ACL2-expression -> ACL2-expression
(defun use-fill-in-context (exp args-to-pull-out hole)
  (let* ((cdr-list (cdr (list.map #'(lambda (_) 'cdr) args-to-pull-out)))
	 (pull-outs (pair.first (list.foldr
				 #'(lambda (var acc)
				     (let* ((acc-list (pair.first acc))
					    (cdr-list (pair.second acc))
					    (cdr-d-result (list.foldr
							   #'(lambda (x acc) (cons x (list acc)))
							   exp cdr-list)))
				       (pair.make (cons `(,var (car ,cdr-d-result))
							acc-list)
						  (cdr cdr-list))))
				 (pair.make () cdr-list) args-to-pull-out))))
    `(let* ,pull-outs
       ,hole)))

;; make the datadefs line up, essentially a projection
(defun make-trivial-stm (live-vars1 defdata1 live-vars2 defdata2 nondet-count)
  ;; require subset
  ;;(assert (list.forall #'(lambda (e2) (list.in e live-vars1)) live-vars2))
  `(definec ,(new-statement-name) (input ,(name-to-type (defdata.name defdata1))) ,(name-to-type (defdata.name defdata2))
     ,(use-fill-in-context 'input
			   (list.map #'car live-vars1)
			   (cons 'list (list.map #'(lambda (var) (if (equal var 'counter)
								     (adjust-counter nondet-count)
								   var))
						 (list.map #'car live-vars2))))))

(defun make-trivial-condition (defdata)
  `(definec ,(new-condition-name) (input ,(name-to-type (defdata.name defdata))) :boolean
     t))

(defun program-to-ACL2-program* (prgm)
  (error 'unimplemented))

;; statement node [bool option] [node list] [edge list] [node-name ACL2-expression map] node [node option] [node option] [c-label node map] [edge list] [c-label [var list] map] -> (list node [bool option] [node list] [edge list] [node-name ACL2-expression map] [c-label node map] [edge list])
;; the created node;; the list of created nodes;; the list of created edges;; the assertions that need to be proved
(defun statement-to-ACL2-statement* (stm to-go-to enter-loop-head nodes edges assertions end-node continue-node break-node label-node-map todo-edges)
  (cond ((equal (car stm) 'compound-statement)
	 (list.foldr #'(lambda (stm* acc)
		    (let* ((to-go-to (car acc))
			   (enter-loop-head (cadr acc))
			   (nodes (caddr acc))
			   (edges (cadddr acc))
			   (assertions (cadddr (cdr acc)))
			   (label-node-map (cadddr (cddr acc)))
			   (todo-edges (cadddr (cdddr acc)))
			   (res (statement-to-ACL2-statement* stm* to-go-to enter-loop-head nodes edges assertions end-node continue-node break-node label-node-map todo-edges))
			   (returned (car res))
			   (enter-loop-head* (cadr res))
			   (nodes* (caddr res))
			   (edges* (cadddr res))
			   (assertions* (cadddr (cdr res)))
			   (label-node-map* (cadddr (cddr res)))
			   (todo-edges* (cadddr (cdddr res))))
		      (list returned enter-loop-head* nodes* edges* assertions* label-node-map* todo-edges*)))
		(list to-go-to enter-loop-head nodes edges assertions label-node-map todo-edges) (l.find stm ':statements)))
	((equal (car stm) 'return-statement)
	 (let* ((n-name (new-node-name))
		(live-vars (list-union (node.live-vars end-node) (expression-free-vars (l.find stm ':expression))))
		(new-node (node.make n-name live-vars))
		(new-edge (edge.make (new-edge-name) new-node end-node
				     t #'(lambda (exp) exp)
				     (list.map #'car (expression-free-vars (l.find stm ':expression)))
				     (l.find stm ':loc)
				     :enter-loop-head enter-loop-head
				     :source-code (option.some (l.find stm ':source-code))
				     :return-from (option.some '|main|)))
		(nodes* (cons new-node nodes))
		(edges* (cons new-edge edges)))
	   (list new-node option.none nodes* edges* assertions label-node-map todo-edges)))
	((equal (car stm) 'if-then-statement)
	 (let* ((res-then (statement-to-ACL2-statement* (l.find stm ':then) to-go-to enter-loop-head nodes edges assertions end-node continue-node break-node label-node-map todo-edges))
		(then-node (car res-then))
		(enter-loop-head* (cadr res-then))
		(nodes* (caddr res-then))
		(edges* (cadddr res-then))
		(assertions* (cadddr (cdr res-then)))
		(label-node-map* (cadddr (cddr res-then)))
		(todo-edges* (cadddr (cdddr res-then)))

		(test-exp-res (expression-to-ACL2-expression* (l.find stm ':test) 0))
		(test-exp (car test-exp-res))
		(nondet-count (cadr test-exp-res))
		(test-vars (expression-free-vars (l.find stm ':test)))

		(n-name (new-node-name))
		(live-vars (list-union (node.live-vars then-node) (list-union (node.live-vars to-go-to) test-vars)))
		(new-node (node.make n-name live-vars))

		(then-edge (edge.make (new-edge-name) new-node then-node
				      test-exp
				      (if (> nondet-count 0)
					  #'(lambda (exp)
					      `(let ((counter ,(adjust-counter nondet-count)))
						 ,exp))
					#'(lambda (exp) exp))
				      (list.map #'car (expression-free-vars (l.find stm ':test)))
				      (l.find (l.find stm ':test) ':loc)
				      :enter-loop-head enter-loop-head*
				      :control (option.some 'condition-true) 
				      :source-code (option.some (l.find (l.find stm ':test) ':source-code))))
		(fall-through-edge (edge.make (new-edge-name) new-node to-go-to
					      (list 'not test-exp)
					      (if (> nondet-count 0)
						  #'(lambda (exp)
						      `(let ((counter ,(adjust-counter nondet-count)))
							 ,exp))
						#'(lambda (exp) exp))
					      (list.map #'car (expression-free-vars (l.find stm ':test)))
					      (l.find (l.find stm ':test) ':loc)
					      :enter-loop-head enter-loop-head 
					      :control (option.some 'condition-false) 
					      :source-code (option.some (string-append "!(" (string-append (l.find (l.find stm ':test) ':source-code) ")")))))
		(nodes** (cons new-node nodes*))
		(edges** (cons then-edge (cons fall-through-edge edges*))))
	   (list new-node option.none nodes** edges** assertions* label-node-map* todo-edges*)))

	((equal (car stm) 'if-then-else-statement)
	 (let* ((res-then (statement-to-ACL2-statement* (l.find stm ':then) to-go-to enter-loop-head nodes edges assertions end-node continue-node break-node label-node-map todo-edges))
		(then-node (car res-then))
		(enter-loop-head* (cadr res-then))
		(nodes* (caddr res-then))
		(edges* (cadddr res-then))
		(assertions* (cadddr (cdr res-then)))
		(label-node-map* (cadddr (cddr res-then)))
		(todo-edges* (cadddr (cdddr res-then)))

		(res-else (statement-to-ACL2-statement* (l.find stm ':else) to-go-to enter-loop-head nodes* edges* assertions* end-node continue-node break-node label-node-map* todo-edges*))
		(else-node (car res-else))
		(enter-loop-head** (cadr res-then))
		(nodes** (caddr res-else))
		(edges** (cadddr res-else))
		(assertions** (cadddr (cdr res-else)))
		(label-node-map** (cadddr (cddr res-else)))
		(todo-edges** (cadddr (cdddr res-else)))

		(test-exp-res (expression-to-ACL2-expression* (l.find stm ':test) 0))
		(test-exp (car test-exp-res))
		(nondet-count (cadr test-exp-res))
		(test-vars (expression-free-vars (l.find stm ':test)))
		
		(n-name (new-node-name))
		(live-vars (list-union (node.live-vars then-node)
				       (list-union (node.live-vars else-node) test-vars)))
		(new-node (node.make n-name live-vars))

		(then-edge (edge.make (new-edge-name) new-node then-node 
				      test-exp 
				      (if (> nondet-count 0)
					  #'(lambda (exp)
					      `(let ((counter ,(adjust-counter nondet-count)))
						 ,exp))
					#'(lambda (exp) exp))
				      (list.map #'car (expression-free-vars (l.find stm ':test)))
				      (l.find (l.find stm ':test) ':loc)
				      :enter-loop-head enter-loop-head*
				      :control (option.some 'condition-true) 
				      :source-code (option.some (l.find (l.find stm ':test) ':source-code))))
		(else-edge (edge.make (new-edge-name) new-node else-node 
				      (list 'not test-exp) 
				      (if (> nondet-count 0)
					  #'(lambda (exp)
					      `(let ((counter ,(adjust-counter nondet-count)))
						 ,exp))
					#'(lambda (exp) exp))
				      (list.map #'car (expression-free-vars (l.find stm ':test)))
				      (l.find (l.find stm ':test) ':loc)
				      :enter-loop-head enter-loop-head**
				      :control (option.some 'condition-false) 
				      :source-code (option.some (string-append "!(" (string-append (l.find (l.find stm ':test) ':source-code) ")")))))
		(nodes*** (cons new-node nodes**))
		(edges*** (cons then-edge (cons else-edge edges**))))
	   (list new-node option.none nodes*** edges*** assertions** label-node-map** todo-edges**)))

	((equal (car stm) 'while-statement)
	 (let* ((test-exp-res (expression-to-ACL2-expression* (l.find stm ':test) 0))
		(test-exp (car test-exp-res))
		(nondet-count (cadr test-exp-res))
		(live-vars (list-union (node.live-vars to-go-to)
				       (list-union (expression-free-vars (l.find stm ':test))
						   (statement-free-vars (l.find stm ':body)))))
		(new-node (node.make (new-node-name) live-vars))

		(loop-node (node.make (new-loop-node-name) live-vars))

		(res-body (statement-to-ACL2-statement* (l.find stm ':body) loop-node (option.some t) nodes edges assertions end-node (option.some loop-node) (option.some to-go-to) label-node-map todo-edges))
		(body-node (car res-body))
		(enter-loop-head* (cadr res-body))
		(nodes* (caddr res-body))
		(edges* (cadddr res-body))
		(assertions* (cadddr (cdr res-body)))
		(label-node-map* (cadddr (cddr res-body)))
		(todo-edges* (cadddr (cdddr res-body)))

		(body-edge (edge.make (new-edge-name) loop-node body-node 
				      test-exp
				      (if (> nondet-count 0)
					  #'(lambda (exp)
					      `(let ((counter ,(adjust-counter nondet-count)))
						 ,exp))
					#'(lambda (exp) exp))
				      (list.map #'car (expression-free-vars (l.find stm ':test)))
				      (l.find (l.find stm ':test) ':loc)
				      :enter-loop-head enter-loop-head*
				      :control (option.some 'condition-true) 
				      :source-code (option.some (l.find (l.find stm ':test) ':source-code))))
		(fall-through-edge (edge.make (new-edge-name) loop-node to-go-to
					      (list 'not test-exp) 
					      (if (> nondet-count 0)
						  #'(lambda (exp)
						      `(let ((counter ,(adjust-counter nondet-count)))
							 ,exp))
						#'(lambda (exp) exp))
					      (list.map #'car (expression-free-vars (l.find stm ':test)))
					      (l.find (l.find stm ':test) ':loc)
					      :enter-loop-head enter-loop-head 
					      :control (option.some 'condition-false) 
					      :source-code (option.some (string-append "!(" (string-append (l.find (l.find stm ':test) ':source-code) ")")))))
		(triv-edge (edge.make (new-edge-name) new-node loop-node
				      t #'(lambda (exp) exp)
				     ()
				     (l.find (l.find stm ':test) ':loc)
				      :enter-loop-head (option.some t)
				      :source-code option.none))
	 
		(nodes** (append (if *use-loop-header-nodes* (list new-node) ()) (list loop-node) nodes*))
		(edges** (append (list body-edge fall-through-edge) (if *use-loop-header-nodes* (list triv-edge) ()) edges*)))
	   (list (if *use-loop-header-nodes* new-node loop-node) (if *use-loop-header-nodes* option.none (option.some t)) nodes** edges** assertions* label-node-map* todo-edges*)))

	((equal (car stm) 'do-statement)
	 (error 'unimplemented (list stm)))
	((equal (car stm) 'for-statement)
	 (let* ((test-exp-res (expression-to-ACL2-expression* (l.find stm ':test) 0))
		(test-exp (car test-exp-res))
		(nondet-count (cadr test-exp-res))
		(live-vars (list-union (node.live-vars to-go-to)
				       (list-union (expression-free-vars (l.find stm ':test))
						   (list-union (statement-free-vars (l.find stm ':iter))
							       (statement-free-vars (l.find stm ':body))))))
		(new-node (node.make (new-node-name) live-vars))

		(loop-node (node.make (new-loop-node-name) live-vars))

		(res-iter (statement-to-ACL2-statement* (l.find stm ':iter) loop-node (option.some t) nodes edges assertions end-node option.none option.none label-node-map todo-edges)) ;; TODO
		(enter-loop-head* (cadr res-iter))
		(iter-node (car res-iter))
		(nodes* (caddr res-iter))
		(edges* (cadddr res-iter))
		(assertions* (cadddr (cdr res-iter)))
		(label-node-map* (cadddr (cddr res-iter)))
		(todo-edges* (cadddr (cdddr res-iter)))

		(res-body (statement-to-ACL2-statement* (l.find stm ':body) iter-node enter-loop-head* nodes* edges* assertions* end-node (option.some loop-node) (option.some to-go-to) label-node-map* todo-edges*))
		
		(body-node (car res-body))
		(enter-loop-head** (cadr res-body))
		(nodes** (caddr res-body))
		(edges** (cadddr res-body))
		(assertions** (cadddr (cdr res-body)))
		(label-node-map** (cadddr (cddr res-body)))
		(todo-edges** (cadddr (cdddr res-body)))

		(body-edge (edge.make (new-edge-name) loop-node body-node 
				      test-exp
				      (if (> nondet-count 0)
					  #'(lambda (exp)
					      `(let ((counter ,(adjust-counter nondet-count)))
						 ,exp))
					#'(lambda (exp) exp))
				      (list.map #'car (expression-free-vars (l.find stm ':test)))
				      (l.find (l.find stm ':test) ':loc)
				      :enter-loop-head enter-loop-head**
				      :control (option.some 'condition-true) 
				      :source-code (option.some (l.find (l.find stm ':test) ':source-code))))
		(fall-through-edge (edge.make (new-edge-name) loop-node to-go-to
					      (list 'not test-exp)
					      (if (> nondet-count 0)
						  #'(lambda (exp)
						      `(let ((counter ,(adjust-counter nondet-count)))
							 ,exp))
						#'(lambda (exp) exp))
					      (list.map #'car (expression-free-vars (l.find stm ':test)))
					      (l.find (l.find stm ':test) ':loc)
					      :enter-loop-head enter-loop-head 
					      :control (option.some 'condition-false) 
					      :source-code (option.some (string-append "!(" (string-append (l.find (l.find stm ':test) ':source-code) ")")))))
		(triv-edge (edge.make (new-edge-name) new-node loop-node 
				      t #'(lambda (exp) exp)
				      ()
				      (l.find (l.find stm ':test) ':loc)
				      :enter-loop-head (option.some t)
				      :source-code option.none))
							 
		(nodes*** (append (if *use-loop-header-nodes* (list new-node) ()) (list loop-node) nodes**))
		(edges*** (append (list body-edge fall-through-edge) (if *use-loop-header-nodes* (list triv-edge) ()) edges**)))
	   (statement-to-ACL2-statement* (l.find stm ':init) (if *use-loop-header-nodes* new-node loop-node) (if *use-loop-header-nodes* option.none (option.some t)) nodes*** edges*** assertions** end-node option.none option.none label-node-map** todo-edges**))) ;; TODO

	((equal (car stm) 'empty-statement)
	 (let* ((n-name (new-node-name))
		(live-vars (node.live-vars to-go-to))
		(new-node (node.make n-name live-vars))
		(new-edge (edge.make (new-edge-name) new-node to-go-to 
				     t #'(lambda (exp) exp)
				     ()
				     (l.find stm ':loc)
				     :enter-loop-head enter-loop-head
				     :source-code (option.some (l.find stm ':source-code))))
		(nodes* (cons new-node nodes))
		(edges* (cons new-edge edges)))
	   (list new-node option.none nodes* edges* assertions label-node-map todo-edges)))
	((equal (car stm) 'break-statement)
	 (let* ((break-node (if (option.exists break-node) (option.get break-node) (error 'no-conversion (list stm))))
		(n-name (new-node-name))
		(live-vars (node.live-vars break-node))
		(new-node (node.make n-name live-vars))
		(new-edge (edge.make (new-edge-name) new-node break-node 
				     t #'(lambda (exp) exp)
				     ()
				     (l.find stm ':loc)
				     :enter-loop-head enter-loop-head 
				     :source-code (option.some (l.find stm ':source-code))))
		(nodes* (cons new-node nodes))
		(edges* (cons new-edge edges)))
	   (list new-node option.none nodes* edges* assertions label-node-map todo-edges)))
	((equal (car stm) 'continue-statement)
	 (let* ((continue-node (if (option.exists continue-node) (option.get continue-node) (error 'no-conversion (list stm))))
		(n-name (new-node-name))
		(live-vars (node.live-vars continue-node))
		(new-node (node.make n-name live-vars))
		(new-edge (edge.make (new-edge-name) new-node continue-node 
				     t #'(lambda (exp) exp)
				     ()
				     (l.find stm ':loc)
				     :enter-loop-head enter-loop-head
				     :source-code (option.some (l.find stm ':source-code))))
		(nodes* (cons new-node nodes))
		(edges* (cons new-edge edges)))
	   (list new-node option.none nodes* edges* assertions label-node-map todo-edges)))

	((equal (car stm) 'declaration-statement)
	 (let* ((init-exp-res (expression-to-ACL2-expression* (l.find stm ':initializer) 0))
		(init-exp (car init-exp-res))
		(nondet-count (cadr init-exp-res))
		(init-vars (expression-free-vars (l.find stm ':initializer)))

		(type (type-to-ACL2-type (l.find (l.find stm ':declaring) ':type)))
		(var (var.ACL2-var (l.find (l.find stm ':declaring) ':var)))
		
		(n-name (new-node-name))
		(live-vars (list.remove (list var type)
					(list-union (node.live-vars to-go-to) init-vars)))
		(new-node (node.make n-name live-vars))

		(declare-edge (edge.make (new-edge-name) new-node to-go-to 
					 t
					 (if (> nondet-count 0)
					     #'(lambda (exp)
						 `(let ((,var ,init-exp))
						    (let ((counter ,(adjust-counter nondet-count)))
						      ,exp)))
					   #'(lambda (exp) 
					       `(let ((,var ,init-exp))
						  ,exp)))
					 (list.map #'car (expression-free-vars (l.find stm ':initializer)))
					 (l.find stm ':loc)
					 :enter-loop-head enter-loop-head
					 :source-code (option.some (l.find stm ':source-code))))
		(nodes* (cons new-node nodes))
		(edges* (cons declare-edge edges)))
	   (list new-node option.none nodes* edges* assertions label-node-map todo-edges)))

	((equal (car stm) 'assignment-statement)
	 (let* ((rhs-exp-res (expression-to-ACL2-expression* (l.find stm ':expression) 0))
		(rhs-exp (car rhs-exp-res))
		(nondet-count (cadr rhs-exp-res))
		(rhs-vars (expression-free-vars (l.find stm ':expression)))

		(lvalue (l.find stm ':lvalue))
		(var (var.ACL2-var (l.find lvalue ':var)))
		(type (type-to-ACL2-type (l.find (l.find stm ':expression) ':type)))
		
		(n-name (new-node-name))
		(live-vars (list-union (node.live-vars to-go-to)
				       rhs-vars))
		(new-node (node.make n-name live-vars))

		(assign-edge (edge.make (new-edge-name) new-node to-go-to 
					 t
					 (if (> nondet-count 0)
					     #'(lambda (exp)
						 `(let ((,var ,rhs-exp))
						    (let ((counter ,(adjust-counter nondet-count)))
						      ,exp)))
					   #'(lambda (exp)
					       `(let ((,var ,rhs-exp))
						  ,exp)))
					 (list.map #'car (expression-free-vars (l.find stm ':expression))) ;;; todo: probably don't need the lvalue here
					 (l.find stm ':loc)
					 :enter-loop-head enter-loop-head
					 :source-code (option.some (l.find stm ':source-code))))
		(nodes* (cons new-node nodes))
		(edges* (cons assign-edge edges)))
	   (list new-node option.none nodes* edges* assertions label-node-map todo-edges)))
	((equal (car stm) 'assert-statement)
	 (let* ((assert-exp-res (expression-to-ACL2-expression* (l.find stm ':expression) 0))
		(assert-exp (car assert-exp-res))
		(nondet-count (cadr assert-exp-res))
		(assert-vars (expression-free-vars (l.find stm ':expression)))

		(n-name (new-assert-node-name))
		(live-vars (list-union (node.live-vars to-go-to)
				       assert-vars))
		(new-node (node.make n-name live-vars))

		(assert-edge (edge.make (new-edge-name) new-node to-go-to 
					t
					(if (> nondet-count 0)
					    #'(lambda (exp)
						`(let ((counter ,(adjust-counter nondet-count)))
						   ,exp))
					  #'(lambda (exp) exp))
					(list.map #'car (expression-free-vars (l.find stm ':expression)))
					(l.find stm ':loc)
					:enter-loop-head enter-loop-head
					:source-code (option.some (l.find stm ':source-code))
					:is-assertion t))
		(nodes* (cons new-node nodes))
		(edges* (cons assert-edge edges))
		(assertions* (map.add-exn assertions n-name assert-exp)))
	   (list new-node option.none nodes* edges* assertions* label-node-map todo-edges)))
	((equal (car stm) 'goto-statement)
	 (let* ((new-node (node.make (new-node-name) ()))
		(new-edge (edge.make (new-edge-name) new-node (l.find stm ':label)
				     t
				     #'(lambda (exp) exp)
				     ()
				     (l.find stm ':loc)
				     :enter-loop-head enter-loop-head
				     :source-code (option.some (l.find stm ':source-code))))
		(nodes* (cons new-node nodes))
		(todo-edges* (cons new-edge todo-edges)))
	   (list new-node option.none nodes* edges assertions label-node-map todo-edges*)))
	((equal (car stm) 'label-statement)
	 (let* ((label (l.find stm ':label))
		(n-name (new-node-name))
		(live-vars (node.live-vars to-go-to))
		(new-node (node.make n-name live-vars))
		(new-edge (edge.make (new-edge-name) new-node to-go-to
				     t
				     #'(lambda (exp) exp)
				     ()
				     (l.find stm ':loc)
				     :enter-loop-head enter-loop-head
				     :source-code (option.some (l.find stm ':source-code))))
		(nodes* (cons new-node nodes))
		(edges* (cons new-edge edges))
		(label-node-map* (map.add-exn label-node-map label new-node)))
	   (list new-node option.none nodes* edges* assertions label-node-map* todo-edges)))
	(t (error 'no-statement (list stm)))))

(defparameter *generalize-limit* 10)
;; [(list (list const type) var) list] -> [ACL2-expression list]
(defun create-order-preserving-constraints (pair-pairs)
  (if (endp pair-pairs) ()
    (let* ((var (var.ACL2-var (cadr (car pair-pairs))))
	   (value (car (car (car pair-pairs)))))
      (append (list.map #'(lambda (pair-pair*)
			    (let* ((var* (var.ACL2-var (cadr pair-pair*)))
				   (value* (car (car pair-pair*))))
			      (if (< value value*)
				  (list '< var var*)
				(list '< var* var))))
			(cdr pair-pairs))
	      (create-order-preserving-constraints (cdr pair-pairs))))))

; program -> (list pgraph [node assertion map] node node [ACL2-expression list] [ACL2-expression list])
(defun create-program-graph (prgm &key (generalize-constants t) (order-preserving t))
  (let* ((res (if generalize-constants
		  (program-generalize-constants prgm *generalize-limit*)
		(list prgm ())))
	 (prgm (car res))
	 (extra (cadr res))
	 (extra-liveness (list.map #'(lambda (pair-pair) 
				       (let* ((const-pair (car pair-pair))
					      (var-pair (cadr pair-pair))
					      (var (var.ACl2-var var-pair))
					      (type (cadr const-pair)))
					 (list var type)))
				   extra))
	 (_ (print (list 'extra-liveness extra-liveness)))
	 (start-node (node.make '|node-start| (append '((nondet nondet) (counter nat)) extra-liveness)))
	 (end-node (node.make '|node-end| (append '((nondet nondet) (counter nat)) extra-liveness))) ;; we want the constants to be used throughout the program?
	 (original-constraints (list.map #'(lambda (pair-pair) (let* ((const-pair (car pair-pair))
								      (var-pair (cadr pair-pair))
								      (var (var.ACl2-var var-pair))
								      (value (car const-pair)))
								 (list 'equal var value)))
					 extra))
	 (generalized-constraints (if (not order-preserving) () (create-order-preserving-constraints extra)))
	 (declarations (l.find prgm ':declarations))
	 (main-dec (option.get (list.find #'(lambda (declaration) (and (equal (car declaration) 'function-declaration)
									       (equal (l.find declaration ':name) '|main|)))
						  declarations)))
	 (main-stm (l.find main-dec ':body))
	 ;;(end-node-prev (node.make (new-node-name) (node.live-vars end-node)))
	 ;;(end-node-edge (edge.make (new-edge-name) end-node-prev end-node t #'(lambda (exp) exp) '(loc :start-line 0 :end-line 0 :offset 0 :length 0) ... :return-from (option.some '|main|)))
	 ;;(res (statement-to-ACL2-statement* main-stm end-node-prev option.none (list end-node end-node-prev) (list end-node-edge) map.empty end-node option.none option.none map.empty ()))
	 (res (statement-to-ACL2-statement* main-stm end-node option.none (list end-node) () map.empty end-node option.none option.none map.empty ()))
	 (main-node (car res))
	 (external-nodes ())
	 (res (list.foldr #'(lambda (declaration acc)
				      (if (not (equal (car declaration) 'simple-declaration))
					  acc
					(let* ((to-go-to (car acc))
					       (enter-loop-head (cadr acc))
					       (nodes (caddr acc))
					       (edges (cadddr acc))
					       (assertions (cadddr (cdr acc)))
					       (label-node-map (cadddr (cddr acc)))
					       (todo-edges (cadddr (cdddr acc)))
					       (init-exp-res (expression-to-ACL2-expression* (l.find declaration ':initializer) 0))
					       (init-exp (car init-exp-res))
					       (nondet-count (cadr init-exp-res))
					       (init-vars (expression-free-vars (l.find declaration ':initializer)))
					       (type (type-to-ACL2-type (l.find (l.find declaration ':declaring) ':type)))
					       (var (var.ACL2-var (l.find (l.find declaration ':declaring) ':var)))
					       (n-name (new-node-name))
					       (live-vars (list.remove (list var type)
								       (list-union (node.live-vars to-go-to) init-vars)))
					       (new-node (node.make n-name live-vars))
					       (new-edge (edge.make (new-edge-name) new-node to-go-to 
								    t
								    (if (> nondet-count 0)
									#'(lambda (exp)
									    `(let ((,var ,init-exp)
										   (counter ,(adjust-counter nondet-count)))
									       ,exp))
								      #'(lambda (exp) 
									  `(let ((,var ,init-exp))
									     ,exp)))
								    (list.map #'car (expression-free-vars (l.find declaration ':initializer)))
								    (l.find declaration ':loc)
								    :enter-loop-head enter-loop-head
								    :source-code (option.some (l.find declaration ':source-code))))
					       (_ (setf external-nodes (cons new-node external-nodes)))
					       (nodes* (cons new-node nodes))
					       (edges* (cons new-edge edges)))
					  (list new-node option.none nodes* edges* assertions label-node-map todo-edges))))
			   res declarations))
	 (node (car res))
	 (enter-loop-head (cadr res))
	 (nodes (caddr res))
	 (edges (cadddr res))
	 (assertions (cadddr (cdr res)))
	 (label-node-map (cadddr (cddr res)))
	 (todo-edges (cadddr (cdddr res)))
	 (finished-todo-edges (list.map #'(lambda (todo-edge)
					    (edge.make (edge.name todo-edge) (edge.from todo-edge) (map.find-exn label-node-map (edge.to todo-edge))
						       (edge.condition-expression todo-edge) (edge.statement-expression todo-edge)
						       (edge.vars todo-edge)
						       (edge.loc todo-edge)
						       :enter-loop-head (edge.enter-loop-head todo-edge)
						       :control (edge.control todo-edge)
						       :source-code (edge.source-code todo-edge)
						       :is-assertion (edge.is-assertion todo-edge)))
					todo-edges))
	 (start-edge (edge.make (new-edge-name) start-node node 
				t #'(lambda (exp) exp)
				()
				'(loc :start-line 0 :end-line 0 :offset 0 :length 0)
				:enter-loop-head enter-loop-head :source-code option.none))
	 (pgraph (pgraph.make (cons start-node nodes)
			      (cons start-edge (append finished-todo-edges edges))))
	 (pgraph* (recompute-live-vars pgraph))
	 (main-node* (option.get (list.find #'(lambda (node*) (equal (node.name main-node) (node.name node*))) (pgraph.nodes pgraph*))))
	 (external-nodes* (list.map #'(lambda (node) (option.get (list.find #'(lambda (node*) (equal (node.name node) (node.name node*))) (pgraph.nodes pgraph*)))) external-nodes)))
    (list pgraph* assertions main-node* external-nodes* start-node end-node original-constraints generalized-constraints prgm)))

